<?php
/*
Plugin Name: Dashboard Option Menu Customize
Description: Customization options and help
Plugin URI: http://gqevu6bsiz.chicappa.jp
Version: 1.1.1
Author: gqevu6bsiz
Author URI: http://gqevu6bsiz.chicappa.jp/author/admin/
Text Domain: dashboard-option-menu-customize
Domain Path: /languages
*/

/*  Copyright 2012 gqevu6bsiz (email : gqevu6bsiz@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
	published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

load_plugin_textdomain('dashboard-option-menu-customize', false, basename(dirname(__FILE__)).'/languages');

define ('DASHBOARD_OPTION_MENU_CUSTOMIZE_MANAGE_URL', admin_url('options-general.php').'?page=dashboard_option_menu_customize');
define ('DASHBOARD_OPTION_MENU_CUSTOMIZE_RECORD_NAME', 'dashboard_option_menu_customize');
?>
<?php
function dashboard_option_menu_customize_add_menu() {
	// add menu
	add_options_page(__('Dashboard menu Setting', 'dashboard-option-menu-customize'), __('Dashboard menu Setting', 'dashboard-option-menu-customize'), 'administrator', 'dashboard_option_menu_customize', 'dashboard_option_menu_customize_setting');

	// plugin links
	add_filter('plugin_action_links', 'dashboard_option_menu_customize_plugin_setting', 10, 2);
}



// plugin setup
function dashboard_option_menu_customize_plugin_setting($links, $file) {
	if(plugin_basename(__FILE__) == $file) {
		$settings_link = '<a href="'.DASHBOARD_OPTION_MENU_CUSTOMIZE_MANAGE_URL.'">'.__('Settings').'</a>';
		$support_link = '<a href="http://wordpress.org/support/plugin/dashboard-option-menu-customize" target="_blank">' . __( 'Support Forums' ) . '</a>';

		array_unshift( $links, $settings_link , $support_link );
	}
	return $links;
}
add_action('admin_menu', 'dashboard_option_menu_customize_add_menu');



// setting
function dashboard_option_menu_customize_setting() {

	add_filter( 'admin_footer_text' , 'dashboard_option_menu_customize_admin_footer_text' );

	$UPFN = 'sett';
	$Msg = '';

	// get menu
	$DisplayMenu = dashboard_option_menu_customize_menuload();

	// get role
	$UserRole = dashboard_option_menu_customize_roleload();

	if(!empty($_POST[$UPFN])) {
		// update
		if($_POST[$UPFN] == 'Y') {
			unset($_POST[$UPFN]);

			$Update = array($_POST["update"]);
			if(!empty($_POST["update"])) {
				foreach ($_POST["update"] as $key => $val) {
					if(!empty($val) && is_array($val)) {
						foreach($val as $menu => $on) {
							$Update[$key][strip_tags($menu)] = strip_tags($on);
						}
					} else {
						$Update[$key][] = "";
					}
				}
			}

			if(!empty($Update)) {
				update_option(DASHBOARD_OPTION_MENU_CUSTOMIZE_RECORD_NAME, $Update);
				$Msg = '<div class="updated"><p><strong>'.__('Settings saved.').'</strong></p></div>';
			}
		}
	}
	
	// get data
	$Data = get_option(DASHBOARD_OPTION_MENU_CUSTOMIZE_RECORD_NAME);
?>
<div class="wrap">
	<div class="icon32" id="icon-themes"></div>
	<h2><?php _e('Dashboard option menu setting', 'dashboard-option-menu-customize'); ?></h2>
	<?php echo $Msg; ?>
	<p>&nbsp;</p>

	<form id="dashboard_option_menu_customize" method="post" action="<?php echo DASHBOARD_OPTION_MENU_CUSTOMIZE_MANAGE_URL; ?>">
		<input type="hidden" name="<?php echo $UPFN; ?>" value="Y">
		<?php wp_nonce_field(-1, '_wpnonce', false); ?>

		<div class="metabox-holder columns-2">

			<div class="postbox-container" id="postbox-container-1">

				<div id="update">
					<h3 style="font-weight: bold;"><?php _e('Reading Settings'); ?></h3>
					<?php $mode = 'update'; ?>
					<input type="hidden" name="<?php echo $mode; ?>[]" value="1" />
		
					<table cellspacing="0" class="widefat ">
						<thead>
							<tr>
								<th class="role"><?php _e('User Roles'); ?></th>
								<?php foreach($DisplayMenu as $menu => $menuname) : ?>
									<th class="<?php echo $menu; ?>"><?php echo $menuname; ?></th>
								<?php endforeach; ?>
							</tr>
						</thead>
						<tbody>
		
							<?php foreach($UserRole as $role => $rolename) : ?>
								<tr>
									<td class="role">
										<?php echo $rolename; ?>
									</td>
									<?php foreach($DisplayMenu as $menu => $menuname) : ?>
										<td class="<?php echo $menu; ?>">
											<?php $Checked = ''; ?>
											<?php if(!empty($Data[$role][$menu])) : ?>
												<?php $Checked = 'checked="checked"'; ?>
											<?php endif; ?>
											<label>
												<input type="checkbox" name="<?php echo $mode; ?>[<?php echo $role; ?>][<?php echo $menu; ?>]" value="1" <?php echo $Checked; ?> /> <?php _e('Hide'); ?>
											</label>
										</td>
									<?php endforeach; ?>
								</tr>
							<?php endforeach; ?>
		
						</tbody>
					</table>
					<p class="submit">
						<input type="submit" class="button-primary" value="<?php _e('Save'); ?>" />
					</p>

					<p>&nbsp;</p>
					<p><?php _e( 'This plugin If you want to change the menu option other than the dashboard.' , 'dashboard-option-menu-customize' ); ?></p>
					<p><a href="http://wordpress.org/extend/plugins/screen-options-and-help-show-customize/" target="_blank">Screen Options and Help Show Customize</a></p>
		
				</div>
			</div>
			
			<div class="postbox-container" id="postbox-container-2">
				<div class="stuffbox" id="usefulbox">
					<h3><span class="hndle"><?php _e( 'Useful plugins' , 'dashboard-option-menu-customize' ); ?></span></h3>
					<div class="inside">
						<p><strong><a href="http://wpadminuicustomize.com/" target="_blank">WP Admin UI Customize</a></strong></p>
						<p class="description"><?php _e( 'Customize a variety of screen management.' , 'dashboard-option-menu-customize' ); ?></p>
						<p><strong><a href="http://wordpress.org/extend/plugins/screen-options-and-help-show-customize/" target="_blank">Screen Options and Help Show Customize</a></strong></p>
						<p class="description"><?php _e( 'Set display options and getting help, and set the default page for almost all. Further change the display for each user role.' , 'dashboard-option-menu-customize' ); ?></p>
						<p>&nbsp;</p>
					</div>
				</div>

				<div class="stuffbox" id="aboutbox">
					<h3><span class="hndle"><?php _e( 'About plugin' , 'dashboard-option-menu-customize' ); ?></span></h3>
					<div class="inside">
						<p><?php _e( 'Version check' , 'dashboard-option-menu-customize' ); ?> : 3.4.2 - 3.6 beta 3</p>
						<ul>
							<li><a href="http://gqevu6bsiz.chicappa.jp/?utm_source=use_plugin&utm_medium=side&utm_content=domc&utm_campaign=1_1" target="_blank"><?php _e( 'Developer\'s site' , 'dashboard-option-menu-customize' ); ?></a></li>
							<li><a href="http://wordpress.org/support/plugin/dashboard-option-menu-customize" target="_blank"><?php _e( 'Support Forums' ); ?></a></li>
							<li><a href="http://wordpress.org/support/view/plugin-reviews/dashboard-option-menu-customize" target="_blank"><?php _e( 'Reviews' , 'dashboard-option-menu-customize' ); ?></a></li>
							<li><a href="https://twitter.com/gqevu6bsiz" target="_blank">twitter</a></li>
							<li><a href="http://www.facebook.com/pages/Gqevu6bsiz/499584376749601" target="_blank">facebook</a></li>
						</ul>
					</div>
				</div>

			</div>
			
			<div class="clear"></div>
			
		</div>

	</form>
</div>

<style>
.columns-2 {
	margin-right: 300px;
}
#postbox-container-1 {
	float: left;
	width: 100%;
}
#postbox-container-2 {
	float: right;
	width: 280px;
	margin-right: -300px;
}

.postbox-container #donationbox {
	background: #87BCE4;
	border: 3px solid #227499;
}
.postbox-container #donationbox .inside {
	padding: 6px 10px 10px 10px;
}
.postbox-container #donationbox .inside .donation_memo {
	background: #FFF8D9;
	padding: 2px 10px;
}
</style>
<?php
}


// footer text
function dashboard_option_menu_customize_admin_footer_text( $text ) {
	
	$text = '<img src="http://www.gravatar.com/avatar/7e05137c5a859aa987a809190b979ed4?s=18" width="18" /> Plugin developer : <a href="http://gqevu6bsiz.chicappa.jp/?utm_source=use_plugin&utm_medium=footer&utm_content=domc&utm_campaign=1_1" target="_blank">gqevu6bsiz</a>';
	
	return $text;
}






// get mnenu
function dashboard_option_menu_customize_menuload() {
	$DisplayMenu = array('help' => __('Help'), 'screenoption' => __('Screen Options'));

	return $DisplayMenu;
}



// get role
function dashboard_option_menu_customize_roleload() {
	$UserRole = array();
	$editable_roles = get_editable_roles();
	foreach ( $editable_roles as $role => $details ) {
		$UserRole[$role] = translate_user_role($details['name'] );
	}

	return $UserRole;
}



// screen_opton_action
function dashboard_option_menu_customize_screen_option_add() {
	return false;
}




// menu hide
function dashboard_option_menu_customize_show() {
	$screen = get_current_screen();

	if($screen->base == 'dashboard') {
		// get data
		$Data = get_option(DASHBOARD_OPTION_MENU_CUSTOMIZE_RECORD_NAME);

		if(!empty($Data)) {
			// get type
			$DisplayMenu = dashboard_option_menu_customize_menuload();

			$User = wp_get_current_user();
			$Userroles = $User->roles[0];

			foreach($DisplayMenu as $menu => $menuname) {
				if(!empty($Data[$Userroles][$menu])) {
					if($menu == 'help') {
						// help hide
						$screen->remove_help_tabs();
					} else if($menu == 'screenoption') {
						// screen option hide
						add_action('screen_options_show_screen', 'dashboard_option_menu_customize_screen_option_add');
					}
				}
			}
		}

	}
}
add_action('admin_head', 'dashboard_option_menu_customize_show');
?>